#  Title screen font from - http://www.zee-3.com/pickfordbros/archive/bitmapfonts.php
# "Feel free to use any of these fonts for whatever purpose you see fit."
#
#


## Pokkito python
import upygame as upg
import umachine as pok
import gfx
import gc
import urandom as rand

currentCard = 0
moveStyle = 0

GameMode = 0
moveMax = 0
numMoves = 0
firstRun=1
holdingWildcard= 0
cardsLeft = 0
titleFrames = [0,1,2,2,3,0]
titleOffset = [17,17,16,16,10,0]

easeOutBounce = [
	0,0,0,1,3,4,6,9,12,15,
	19,23,27,32,37,43,49,55,62,69,
	77,85,93,102,111,120,130,140,151,162,
	173,185,197,210,222,236,249,250,244,237,
	232,226,221,216,212,208,205,202,199,197,
	195,193,192,191,191,191,191,192,193,195,
	196,199,201,205,208,212,216,221,226,231,
	237,243,250,254,250,248,245,243,241,240,
	239,239,239,239,239,241,242,244,246,249,
	251,254,253,252,251,251,251,251,252,253];


#cardList = [56]
#cardFace = [56]
#             1,2,3,4,5,6,7,8,9,10, K, Q, J, W
moveCounts = [1,2,3,4,5,6,7,8,9,10,99,99, 0, 1]
cursorStyle =[1,1,1,1,1,1,1,1,1,1 , 2, 2, 1, 1]

lastCardX = [80,90,80,90]
lastCardY = [55,55,65,65]
lastJack = 0
animLength = 10
numWildCards = 0
wildOrder = [0,0,0,0]

cardList = [0 for x in range(56)]
cardFace = [0 for x in range(56)]
bounces = [0 for x in range (6)] # for titlescreen anim

def shuffle():
    sampleSize = 56

    doneShuffle = 0
    
    while doneShuffle == 0:

        s = len(cardList)
        for n in range(0, s):
            cardList[n] = n
        for n in range(0, s):
            rnd = rand.getrandbits(30)%s
            tmp = cardList[n]
            cardList[n] = cardList[rnd]
            cardList[rnd] = tmp
            cardFace[n] = 0

        cardFace[49] = 1
        cardFace[50] = 1
        cardFace[51] = 1
        cardFace[52] = 1
    
        doneShuffle = 1
        if cardList[49]%14 == 12 or cardList[50]%14 == 12 or cardList[51]%14 == 12 or cardList[52]%14 == 12:
            doneShuffle = 0


card = gfx.card()
cursor = gfx.cursor()
title = gfx.title()
text = gfx.text()

shuffle()

currentCard = 0
moveStyle = 0
moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
numMoves = 0
currentCard = cardList[cursor.x+7*cursor.y]%14
cur = cursorStyle[currentCard]

# movestyles
# 0 = anywhere
# 1 = horizontally
# 2 = vertically
# 3 = anywhere without collisison!


def easeInOut(t, b, c, d):
    
    # linear
    return ((t*c)//d)+b



def renderScreen():
    global cur

    # Render screen
    screen.fill(0x7)

    # current move
    text.draw(screen,12,78,(moveMax-numMoves)//10)
    text.draw(screen,16,78,(moveMax-numMoves)%10)
    text.draw(screen,25,78,10) # MOVES
    text.draw(screen,51,78,12) # LEFT
    # moves left
    text.draw(screen,85,5,(cardsLeft)//10)
    text.draw(screen,89,5,(cardsLeft)%10)
    text.draw(screen,80,11,11) # MOVES
    text.draw(screen,82,17,12) # LEFT
    
    # place holders
    cursor.draw(screen, 80,29,0)
    cursor.draw(screen, 90,29,0)
    cursor.draw(screen, 80,39,0)
    cursor.draw(screen, 90,39,0)
    cursor.draw(screen, 80,55,0)
    cursor.draw(screen, 90,55,0)
    cursor.draw(screen, 80,65,0)
    cursor.draw(screen, 90,65,0)

    a = 0
    # main grid
    for y in range(0,7):
        for x in range(0,7):
            card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[x+7*y])
            a+=1

    # last 4 cards
    for y in range(0,4):
        card.draw(screen, lastCardX[y], lastCardY[y], (cardList[a]%14)+1, cardList[a]//14,1)#cardFace[a]
        a+=1

    # wildCards
    for t in range(0,numWildCards):
        card.draw(screen, lastCardX[t], lastCardY[t]-26, 14, wildOrder[t],1)


    cursor.draw(screen, cursor.x*10+5, cursor.y*10+5, cur)

    if cursor.x != cursor.sx or cursor.y != cursor.sy:
        card.draw(screen, cursor.x*10+5, cursor.y*10+5, 0,0,3)






def flipCard(x,y):
    a = x+7*y
    for t in range(0,7):
        renderScreen()
        card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[a]+4+t)
        # Update the display
        upg.display.flip()


def unFlipCard(x,y):
    a = x+7*y
    for t in range(0,5):
        renderScreen()
        card.draw(screen, x*10+5, y*10+5, (cardList[a]%14)+1, cardList[a]//14,cardFace[a]+4+t)
        # Update the display
        upg.display.flip()
    cardFace[a] = 4
    dirtyRect = upg.Rect(x*10+5, y*10+5, 7, 6)
    screen.fill(7, dirtyRect)


def checkUp():
    if cursor.y == 0: return 0
    if cur == 3: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[cursor.x+7*(cursor.y-1)] == 0:
        if moveStyle != 1:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 2:
            if numMoves < moveMax:
                return 1
    return 0

def checkDown():
    if cursor.y == 6: return 0
    if cur == 3: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[cursor.x+7*(cursor.y+1)] == 0:
        if moveStyle != 1:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 2:
            if numMoves < moveMax:
                return 1
    return 0

def checkLeft():
    if cursor.x == 0: return 0
    if cur == 4: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[(cursor.x-1)+7*cursor.y] == 0:
        if moveStyle != 2:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 1:
            if numMoves < moveMax:
                return 1
    return 0

def checkRight():
    if cursor.x == 6: return 0
    if cur == 4: return 0
    if moveMax == 99 or holdingWildcard==1: return 1
    if cardFace[(cursor.x+1)+7*cursor.y] == 0:
        if moveStyle != 2:
            if numMoves < moveMax:
                return 1
    else:
        if moveStyle == 1:
            if numMoves < moveMax:
                return 1
    return 0

# Setup the screen.
screen = upg.display.set_mode()


def checkJack(xx,yy):
    global animLength
    global lastJack
    # got a jack?
    if cardList[xx+7*yy]%14 == 12:
        a = cardList[xx+7*yy] 
        cx = xx*10+5
        cy = yy*10+5
        for t in range(0,animLength):
            x = easeInOut(t, cx, lastCardX[lastJack]-cx, animLength)
            y = easeInOut(t, cy, lastCardY[lastJack]-cy, animLength)
            x1 = lastCardX[lastJack]+(cx-x)
            y1 = lastCardY[lastJack]+(cy-y)
            renderScreen()
                            
            dirtyRect = upg.Rect(cx, cy, 9, 8)
            screen.fill(0x7, dirtyRect)
            dirtyRect = upg.Rect(lastCardX[lastJack], lastCardY[lastJack], 9, 8)
            screen.fill(0x7, dirtyRect)

            card.draw(screen, x, y, (a%14)+1, a//14, cardFace[xx+7*yy])
            card.draw(screen, x1, y1, (cardList[lastJack+49]%14)+1, cardList[lastJack+49]//14, cardFace[lastJack+49])
            upg.display.flip()

        temp = cardList[xx+7*yy]
        cardList[xx+7*yy] = cardList[49 + lastJack]
        cardList[49 + lastJack] = temp
        lastJack +=1

def checkWild(xx,yy):
    global animLength
    global numWildCards
    # got a wildcard?
    if cardList[xx+7*yy]%14 == 13:
        a = cardList[xx+7*yy] 
        cx = xx*10+5
        cy = yy*10+5
        for t in range(0,animLength):
            x = easeInOut(t, cx, lastCardX[numWildCards]-cx, animLength)
            y = easeInOut(t, cy, (lastCardY[numWildCards]-26)-cy, animLength)
            renderScreen()
                            
            card.draw(screen, x, y, (a%14)+1, a//14, cardFace[xx+7*yy])
            upg.display.flip()
                
        wildOrder[numWildCards]=a//14
        numWildCards +=1




def newGame():
    global GameMode
    global firstRun
    global numWildCards
    global cardsLeft
    global lastJack

    lastJack=0
    numWildCards = 0
    cursor.sx = rand.getrandbits(30)%7
    cursor.sy = rand.getrandbits(30)%7
    GameMode = 1
    shuffle()
    cursor.x = cursor.sx
    cursor.y = cursor.sy
    cardFace[cursor.x+7*cursor.y] = 1
    firstRun=1
    holdingWildcard=0
    cardsLeft = 49

titleAnim = 0
titleFrame = [0,0,0,0,0,0]
frameNumber = 0


txtScroll = 5
txtScrollDir = 0
def instructionsScreen():
    global GameMode
    global txtScroll
    global txtScrollDir


    txtScroll += txtScrollDir
    if txtScroll > 5:
        txtScroll = 5;
    if txtScroll < -170:
        txtScroll = -170;


    # Render screen
    screen.fill(0x7)

    pok.draw_text(2, txtScroll + 3, "________", 9)
    pok.draw_text(4, txtScroll + 3, "________", 9)
    pok.draw_text(2, txtScroll + 2, "HOW TO PLAY", 9)

    linePos = txtScroll + 10
    pok.draw_text(2, linePos, "Turn over all of the tiles", 5)
    linePos += 7
    pok.draw_text(2, linePos, "on the game board.", 5)
    linePos += 7
    pok.draw_text(2, linePos, "However, you must move", 5)
    linePos += 7
    pok.draw_text(2, linePos, "exactly the number of", 5)
    linePos += 7
    pok.draw_text(2, linePos, "spaces shown on the", 5)
    linePos += 7
    pok.draw_text(2, linePos, "tile.", 5)
    linePos += 7
    pok.draw_text(2, linePos + 1, "___", 9)
    pok.draw_text(4, linePos + 1, "__", 9)
    pok.draw_text(2, linePos + 0, "KEY", 9)
    linePos += 8
    pok.draw_text(2, linePos, "1-10:Move this many tiles.", 5)
    pok.draw_text(2, linePos, "1-10", 13)
    linePos += 8
    pok.draw_text(2, linePos, "J:Take the top tile from", 5)
    pok.draw_text(2, linePos, "J:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "   The spares pile.", 5)
    linePos += 8
    pok.draw_text(2, linePos, "Q:Pick any tile in the", 5)
    pok.draw_text(2, linePos, "Q:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "  same row or column.", 5)
    linePos += 7
    pok.draw_text(2, linePos, "  However, all tiles in the", 5)
    linePos += 7
    pok.draw_text(2, linePos, "  row or column will be", 5)
    linePos += 7
    pok.draw_text(2, linePos, "  turned.", 5)
    linePos += 8
    pok.draw_text(2, linePos, "K:Same as Q, but only the", 5)
    pok.draw_text(2, linePos, "K:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "  selected tile will be", 5)
    linePos += 7
    pok.draw_text(2, linePos, "  turned.", 5)
    linePos += 8
    pok.draw_text(2, linePos, "!:Move 1 space. BUT! you", 5)
    pok.draw_text(2, linePos, "!:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "   also get a free turn*.", 5)
    linePos += 7
    linePos += 7

    pok.draw_text(2, linePos, "* Free turn will allow you", 5)
    pok.draw_text(2, linePos, "*", 13)
    linePos += 7
    pok.draw_text(2, linePos, "   to move anywhere on", 5)
    linePos += 7
    pok.draw_text(2, linePos, "   the gameboard.", 5)
    linePos += 21

    pok.draw_text(2, linePos + 3, "________", 9)
    pok.draw_text(4, linePos + 3, "________", 9)
    pok.draw_text(2, linePos + 2, "CONTROLS", 9)
    linePos += 10
    pok.draw_text(2, linePos, "D-PAD:Move around the", 5)
    pok.draw_text(2, linePos, "D-PAD:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "   Gameboard.", 5)
    linePos += 7
    pok.draw_text(2, linePos, "A:Flip the current card.", 5)
    pok.draw_text(2, linePos, "A:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "B:Use free turn, or", 5)
    pok.draw_text(2, linePos, "B:", 13)
    linePos += 7
    pok.draw_text(2, linePos, "  reset current turn.", 5)
    linePos += 7
    pok.draw_text(2, linePos, "C:Start new game.", 5)
    pok.draw_text(2, linePos, "C:", 13)
    linePos += 7




    dirtyRect = upg.Rect(0, 0, 109, 6)
    screen.fill(7, dirtyRect)
    


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.K_DOWN:
                txtScrollDir = -1
            if eventtype.key == upg.K_UP:
                txtScrollDir = 1
            if eventtype.key == upg.BUT_A:
                GameMode = 0    
            if eventtype.key == upg.BUT_B:
                GameMode = 0    
            if eventtype.key == upg.BUT_C:
                GameMode = 0    

        if eventtype.type == upg.KEYUP:
            txtScrollDir = 0



def titleScreen():
    global GameMode
    global titleAnim
    global frameNumber

    # keep generating a random number as rand.seed() doesn't seem to do anything
    rnd = rand.getrandbits(30)
    
    titleHeight = 52
    y = titleHeight-16
    
    bounces[0] = titleHeight # N
    bounces[1] = titleHeight # O
    bounces[2] = titleHeight # G
    bounces[3] = titleHeight # G
    bounces[4] = titleHeight # I
    bounces[5] = titleHeight # N
    
    if titleAnim==0:
        #for t in range(0,50):
        while titleFrame[5] != 98:
            frameNumber += 1
            # look up table for bounce effect, math is slow
            x=9
            # Render screen
            screen.fill(0x7)
            for x1 in range(0,6):
        
                bounces[x1] = (easeOutBounce[titleFrame[x1]]*titleHeight)//256
                bounces[x1] -= 16
                if frameNumber > x1*4:
                    titleFrame[x1]+=2
                    if titleFrame[x1] > 98:
                        titleFrame[x1]=98
                #print(titleFrame[x1])
                title.draw(screen,x,bounces[x1],titleFrames[x1])
                x += titleOffset[x1]

            # Update the display
            upg.display.flip()
        titleAnim=1    
    

    # Render screen
    screen.fill(0x7)

    x=9
    title.draw(screen,x,y-1,0)
    x +=17
    title.draw(screen,x,y-1,1)
    x +=17
    title.draw(screen,x,y-1,2)
    x +=16
    title.draw(screen,x,y-1,2)
    x +=16
    title.draw(screen,x,y-1,3)
    x +=10
    title.draw(screen,x,y-1,0)
    x +=16

    pok.draw_text(10, titleHeight + 8, "A - Start Game", 15)
    pok.draw_text(10, titleHeight + 16, "B - Instructions", 15)

    pok.draw_text(10, 8, "Spring 2019 Pokitto", 15)
    pok.draw_text(10,16, "MicroPython Contest", 15)


    # Update the display
    upg.display.flip()

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.BUT_A:
                newGame()    
            if eventtype.key == upg.BUT_B:
                GameMode = 2    



def gameLoop():
    global moveMax
    global currentCard
    global moveStyle
    global numMoves
    global cur
    global animLength
    global lastJack
    global numWildCards
    global holdingWildcard
    global cardsLeft

    # Read a key event.
    eventtype = upg.event.poll()
    if eventtype != upg.NOEVENT:
        if eventtype.type== upg.KEYDOWN:
            if eventtype.key == upg.K_RIGHT:
                if checkRight()!= 0:
                    if moveMax != 99: numMoves += 1
                    cursor.x += 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 1
                        if cur != 4:
                            cur = 3
            if eventtype.key == upg.K_LEFT:
                if checkLeft()!= 0:
                    if moveMax != 99: numMoves += 1
                    cursor.x -= 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 1
                        if cur != 4:
                            cur = 3
            if eventtype.key == upg.K_UP:
                if checkUp() != 0:
                    if moveMax != 99: numMoves += 1
                    cursor.y -= 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 2
                        if cur != 3:
                            cur = 4
            if eventtype.key == upg.K_DOWN:
                if checkDown() != 0:
                    if moveMax != 99: numMoves += 1
                    cursor.y += 1
                    if currentCard == 10 or currentCard == 11:
                        moveStyle = 2
                        if cur != 3:
                            cur = 4

            if eventtype.key == upg.BUT_A:
                if cardFace[cursor.x+7*cursor.y] != 1:
                    if numMoves == moveMax or moveStyle != 0 or holdingWildcard:

                        if holdingWildcard:
                            holdingWildcard = 0
                            numWildCards -=1
    
                        cursor.sx = cursor.x
                        cursor.sy = cursor.y

                        if currentCard == 11:
                            for y in range(0,7):
                                if moveStyle == 2:
                                    if cardFace[cursor.x+7*y] != 1:
                                        flipCard(cursor.x,y)
                                        cardFace[cursor.x+7*y] = 1
                                        cardsLeft -=1
                                        checkJack(cursor.x,y)
                                        checkWild(cursor.x,y)
                                if moveStyle == 1:
                                    if cardFace[y+7*cursor.y] != 1:
                                        flipCard(y,cursor.y)
                                        cardFace[y+7*cursor.y] = 1
                                        cardsLeft -=1
                                        checkJack(y,cursor.y)
                                        checkWild(y,cursor.y)
    
                        # extra check in case current card was flipped above
                        if cardFace[cursor.x+7*cursor.y] != 1:
                            flipCard(cursor.x,cursor.y)
                            cardFace[cursor.x+7*cursor.y] = 1
                            cardsLeft -=1
                            checkJack(cursor.x,cursor.y)
                            checkWild(cursor.x,cursor.y)
    
                        moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
                        numMoves = 0
                        moveStyle = 0
                        currentCard = cardList[cursor.x+7*cursor.y]%14
                        cur = cursorStyle[currentCard]
                        
                        for y in range(0,7):
                            for x in range(0,7):
                                if cardFace[x+7*y] == 2:
                                    cardFace[x+7*y] = 0
                        
                        
                # Collect all freed memory. 
                #gc.collect()    
                # Print free memory amount
                #print ("free:",gc.mem_free())
                            
            if eventtype.key == upg.BUT_B:
                if cursor.x == cursor.sx and cursor.y == cursor.sy:
                    if numWildCards != 0:
                        holdingWildcard = 1
                        moveMax = 99
                else:
                    cursor.x = cursor.sx
                    cursor.y = cursor.sy
                    numMoves = 0
                    moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
                    moveStyle = 0
                    currentCard = cardList[cursor.x+7*cursor.y]%14
                    cur = cursorStyle[currentCard]
                    for y in range(0,7):
                        for x in range(0,7):
                            if cardFace[x+7*y] == 2:
                                cardFace[x+7*y] = 0

            if eventtype.key == upg.BUT_C:
                # put a menu here later
                for y in range(0,7):
                    for x in range(0,7):
                        unFlipCard(x,y)
                newGame()


    if cardFace[cursor.x+7*cursor.y] == 0 and moveStyle == 0 and moveMax != 99:
        cardFace[cursor.x+7*cursor.y] = 2

    renderScreen()
    # Update the display
    upg.display.flip()


    if cardsLeft == 0:
        for y in range(0,7):
            for x in range(0,7):
                unFlipCard(x,y)
        newGame()


while upg.event.poll() == upg.KEYDOWN:
    rnd = rand.getrandbits(30) # something to do in while loop

# The main loop. 
while True:
    if GameMode == 0:
        titleScreen()
    if GameMode == 1:
        if firstRun==1:
            checkJack(cursor.x,cursor.y)
            checkWild(cursor.x,cursor.y)
            cardsLeft -=1
            moveMax = moveCounts[cardList[cursor.x+7*cursor.y]%14]
            numMoves = 0
            moveStyle = 0
            currentCard = cardList[cursor.x+7*cursor.y]%14
            cur = cursorStyle[currentCard]
            firstRun=0
        gameLoop();
    
    if GameMode == 2:
        instructionsScreen()



